#include <unistd.h>
#include <stdint.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <string.h>
#include <fcntl.h>
#include <errno.h>

#include <cameraserver/CameraServer.h>
#include <networktables/NetworkTableInstance.h>
#include <networktables/NetworkTable.h>
#include <networktables/DoubleArrayTopic.h>
#include <frc/geometry/Pose3d.h>

#include <linux/videodev2.h>
#include <opencv2/core/core.hpp>
#include <opencv2/imgcodecs.hpp>
#include <opencv2/highgui.hpp>
#include <thread>
#include <vector>
#include <mutex>
#include <condition_variable>

#include <string>
#include <stdexcept>

using namespace std;

#include "2702math.h"
#include "2702camera.h"

using namespace Rebels;

#include "v4lcam-mp.h"
//#include "fbdisp.h"
#include "dualbpi.h"

#include <signal.h>

void printinfo( v4lcam &cam )
{
	cam.printCaps();
	cam.printStandards();
	cam.printControls();
	printf( "---------------\n" );
}

bool bStop = false;

void sighandler( int nSig )
{
	printf( "Received Signal %d\n", nSig );
	bStop = true;
}

int main( int argc, char **argv )
{
	signal( SIGINT, sighandler );
	signal( SIGKILL, sighandler );
	signal( SIGTERM, sighandler );

	auto ntinst = nt::NetworkTableInstance::GetDefault();
	fmt::print("Setting up NetworkTables client for team 2702\n");
	ntinst.StartClient4("2702Vision");
	ntinst.SetServerTeam(2702);
	ntinst.StartDSClient();
	
	DualBPICam dc( "/dev/video0", "/dev/video1", "comp-bot" );

	dc.SetRawLog( "Raw.log" );
	while( !bStop ) {
		std::this_thread::sleep_for( std::chrono::milliseconds(200) );
	}

	return 0;
}
