#include <string>
#include <vector>
#include <stdexcept>

//#include <frc/geometry/Transform3d.h>
//#include <units/length.h>
//#include <units/angle.h>

//using namespace frc;
using namespace std;

#include "2702math.h"
#include "field.h"

static struct tag {
	int id;
	float x, y, z;
	int dir;
} const s_grTags[] =
{
//	{1,   0.00,   0.000,  0.00,  1},
	{1, 610.96,  42.435, 18.25, -1},
	{2, 610.96, 108.435, 18.25, -1},
	{3, 610.96, 174.435, 18.25, -1},
	{4, 637.15, 265.986, 27.375, -1},
	{5, 14.149, 265.986, 27.375, 1},
	{6, 40.339, 174.435, 18.25, 1},
	{7, 40.339, 108.435, 18.25, 1},
	{8, 40.339,  42.435, 18.25, 1}
 };

FieldXfrms::FieldXfrms() 
{
	std::vector<Rebels::Point2d> vRBPts{ Rebels::Point2d( -3.0, -3.0 ), Rebels::Point2d( 3.0, -3.0 ), Rebels::Point2d( 3.0, 3.0 ), Rebels::Point2d( -3.0, 3.0 ) };

	for( int i = 0; i < 8; i++ ) {
		std::vector<Rebels::Point3d> vCorners;

		for (int c = 0; c < 4; c++) {
			float fX = s_grTags[i].x * 25.4F;
			float fY = (s_grTags[i].y + vRBPts[c].u() * s_grTags[i].dir) * 25.4;
			float fZ = (s_grTags[i].z + vRBPts[c].v()) * 25.4;

			vCorners.push_back( Rebels::Point3d( fX, fY, fZ ) );
		}
		m_vFieldPositions.push_back( vCorners );
	}
}

FieldXfrms::~FieldXfrms()
{
}

#if 0
FieldXfrms myField;

int main( int argc, char **argv )
{
	for( int nTag = 1; nTag <= 8; nTag++ ) {
		std::vector<Rebels::Point3d> const &vTag = myField[nTag];

		printf( "Tag %d\n", nTag + 1 );
		for( int nC = 0; nC < 4; nC++ ) {
			Rebels::Point3d const &p = vTag[nC];
			printf( "  %12.3f %12.3f %12.3f\n", p.x(), p.y(), p.z() );
		}
	}
	return 0;
}
#endif
